# BEGIN SourceDeps(oneline):
BuildRequires: perl(Class/Roles.pm) perl(ExtUtils/MakeMaker.pm) perl(Module/Build.pm) perl(Module/Signature.pm) perl(Scalar/Util.pm) perl(Test/More.pm) perl(Test/Simple.pm)
# END SourceDeps(oneline)
%define module_version 1.00
%define module_name Class-ActsLike
%define _unpackaged_files_terminate_build 1
BuildRequires: rpm-build-perl perl-devel perl-podlators

Name: perl-%module_name
Version: 1.00
Release: alt1
Summary: Perl extension for identifying class behavior similarities
Group: Development/Perl
License: perl
Url: %CPAN %module_name

Source0: http://cpan.org.ua/authors/id/C/CH/CHROMATIC/%module_name-%module_version.tar.gz
BuildArch: noarch

%description
Note: This is a deprecated module.  Use the Class::Roles manpage for new development.
This module uses `Class::Roles' internally and exists for the purpose of
backwards compatibility.  The philosophy of the documentation still applies,
though, so enjoy reading it!

Polymorphism is a fundamental building block of object orientation.  Any two
objects that can receive the same messages with identical semantics can
substitute for each other, regardless of their internal implementations.

Much of the introductory literature explains this concept in terms of
inheritance.  While inheritance is one way for two different classes to provide
different behavior for the same methods, it is not the only way.  Perl modules
such as the DBDs or the Test::MockObject manpage prove that classes do not have to
inherit from a common ancestor to be polymorphically equivalent.

Class::ActsLike provides an alternative to `isa()'.

The example class defined above marks `HappyFunBuilding' as acting like both
the `Bakery' and `Arcade' classes.  It is not necessary to create an ancestor
class of `Building', or to have `HappyFunBuilding' inherit from both
`Bakery' and `Arcade'.  As well, one could say:

  package FauxArcade;

  use Arcade;
  use Class::ActsLike 'Arcade';

  sub new
  {
_my $class = shift;
_bless { _arcade => Arcade->new() }, $class;
  }

Provided that the FauxArcade now delegates all methods an Arcade object can
receive to the contained Arcade object, this expresses the has-a relationship
more accurately.  Code which requires an Arcade object should, when handed an
object, check to see if the object acts like an Arcade object.  The FauxArcade
is suitable for any sort of Hollywood production where the real Arcade is
unnecessary.  This is why actors always seem so good at pinball.

This technique fulfills two goals:

=over 4

=item *

To allow you to check that the class or object you receive can handle the types
of messages you're going to send it.

=item *

To avoid dictating *how* the class or object you receive handles the messages:
inheritance, delegation, composition, or re-implementation.

=back

By default, a new class automatically acts like itself, whether you use
`Class::ActsLike' in its package.  It also automatically acts like all of its
parent classes, again without having had `Class::ActsLike' used in its
namespace.


%prep
%setup -n %module_name-%module_version
rm -f t/0-signature.t

%build
%perl_vendor_build

%install
%perl_vendor_install

%files
%doc README Changes
%perl_vendor_privlib/C*

%changelog
* Tue Oct 15 2013 Igor Vlasenko <viy@altlinux.ru> 1.00-alt1
- initial import by package builder

